=== src/zfile.imageio/CMakeLists.txt ===
add_oiio_plugin (zfile.cpp
                 INCLUDE_DIRS ${ZLIB_INCLUDE_DIRS}
                 LINK_LIBRARIES ${ZLIB_LIBRARIES})
