=== debian/changelog ===
openimageio (2.0.10~dfsg0-1) unstable; urgency=medium

  * New upstream release
  * debian/: debhelper bump 11 -> 12
  * debian/control: S-V bump 4.3.0 -> 4.4.0 (no changes needed)

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 05 Aug 2019 23:09:28 +0200

openimageio (2.0.9~dfsg0-1) unstable; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 08 Jul 2019 15:26:16 +0200

openimageio (2.0.8~dfsg0-1) experimental; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Mon, 03 Jun 2019 22:34:07 +0200

openimageio (2.0.7~dfsg0-1) experimental; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Sat, 06 Apr 2019 14:30:04 +0200

openimageio (2.0.6~dfsg0-1) experimental; urgency=medium

  * New upstream release

 -- Matteo F. Vescovi <mfv@debian.org>  Fri, 15 Mar 2019 22:30:11 +0100
